package be.iminds.ilabt.jfed.restapi.jfedclient;

import be.iminds.ilabt.jfed.espec.bundle.ESpecBundle;
import be.iminds.ilabt.jfed.experiment.Experiment;
import be.iminds.ilabt.jfed.experiment.ExperimentController;
import be.iminds.ilabt.jfed.experiment.ExperimentState;
import be.iminds.ilabt.jfed.highlevel.model.Slice;
import be.iminds.ilabt.jfed.log.Logger;
import be.iminds.ilabt.jfed.lowlevel.GeniUser;
import be.iminds.ilabt.jfed.lowlevel.TestbedInfoSource;
import be.iminds.ilabt.jfed.lowlevel.api_wrapper.StatusDetails;
import be.iminds.ilabt.jfed.lowlevel.authority.AuthorityFinder;
import be.iminds.ilabt.jfed.restapi.debugdata.ClientApiCallDDCollector;
import be.iminds.ilabt.jfed.util.GeniUrn;
import be.iminds.ilabt.jfed.util.JFedTrustStore;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import javax.xml.namespace.QName;
import java.sql.Timestamp;
import java.time.Instant;
import java.util.List;

/**
 * JFedExperimenterApi
 */
public interface JFedExperimenterApi {
    QName Q_BUGREPORT = new QName("bugreport");
    QName Q_CALLS = new QName("calls");
    QName Q_CALL = new QName("call");

    @Nonnull Logger getLogger();

    @Nonnull GeniUser getUser();

    @Nonnull TestbedInfoSource getTestbedInfoSource();

    @Nonnull AuthorityFinder getAuthorityFinder();

    @Nonnull JFedTrustStore getJFedTrustStore();

    boolean removeClientApiCallDDCollector(@Nonnull ClientApiCallDDCollector clientApiCallDDCollector);

    void addClientApiCallDDCollector(@Nonnull ClientApiCallDDCollector clientApiCallDDCollector);

    void setClientApiCallDDCollector(@Nonnull ClientApiCallDDCollector clientApiCallDDCollector);

    List<GeniUrn> getProjectsForUser(@Nonnull GeniUrn user);

    List<GeniUrn> getSlicesForUser(@Nonnull GeniUrn user);

    void createSliceAndSlivers(@Nonnull String sliceName,
                               @Nonnull String project,
                               @Nonnull String rspec,
                               @Nullable Instant expire);
    void createSliceAndSlivers(@Nonnull String sliceName,
                               @Nonnull String project,
                               @Nonnull ESpecBundle experimentSpecificationBundle,
                               @Nullable Instant expire);

    void refreshStatusIfNeeded();

    void recoverSlice(@Nonnull GeniUrn sliceUrn);

    void renewSlice(@Nonnull Timestamp newExpire);

    void deleteSlice();

    @Nullable String getProject();

    @Nullable String getSliceName();

    @Nullable GeniUrn getSliceUrn();

    @Nullable Timestamp getExpire();

    @Nullable String getManifestRspec();

    @Nullable Slice getExperimentSlice();

    @Nullable StatusDetails getExperimentSliceStatus();

    @Nullable Experiment getExperiment();

    @Nullable ExperimentState getExperimentState();

    @Nullable ExperimentController getExperimentController();
}
